// Translated by Nina
// This source code is under public domain
package net.morilib.nina.translate;

public  class ReplaceAction   {

	static final int INITIAL = 0;

	private int STATE;
	private int unread = -1;
	private int gotoSymbol = -1;
	private String matched;

private boolean exeo = false;
private StringBuffer b1, ot;
private String fls;

ReplaceAction() {}

private void _apc(int c) {
	if(c >= 0)  ot.appendCodePoint(c);
}

private void _apb(int c) {
	b1.appendCodePoint(c);
}

private void _putmp(int c) {
	String t;

	if(c != ';') {
		ot.append(b1.toString());
	} else if((t = b1.toString()).equals("EXIT")) {
		exeo = true;
		ot.append("return ");
		ot.append(fls);
	} else {
		ot.append(t);
	}
	b1 = new StringBuffer();
}

public static String replace(String s, String f, boolean[] a) {
	ReplaceAction c = new ReplaceAction();

	c.b1 = new StringBuffer();
	c.ot = new StringBuffer();
	c.fls = f;
	try {
		c.parse(new java.io.StringReader(s));
	} catch(java.io.IOException e) {
		throw new RuntimeException(e);
	}
	c.ot.append(c.b1);
	a[0] = c.exeo;
	return c.ot.toString();
}


	private int _read(java.io.Reader rd) throws java.io.IOException {
		int c;

		if(gotoSymbol >= 0) {
			c = gotoSymbol;
			gotoSymbol = -1;
			return c;
		} else if(unread >= 0) {
			c = unread;
			unread = -1;
			return c;
		} else {
			return rd.read();
		}
	}

	void UNGET(int c) {
		unread = c;
	}

	void GOTOSYMBOL(int c) {
		gotoSymbol = c;
	}

	private boolean _step(int  $c) {
		switch(STATE) {
		case 0:
			if($c >= 34 && $c <= 34) {
				STATE = 1;
				return true;
			} else if($c >= 65 && $c <= 90) {
				STATE = 2;
				return true;
			} else if($c >= 97 && $c <= 122) {
				STATE = 2;
				return true;
			} else {
				STATE = 0;
				return true;
			}
		case 2:
			if($c >= 48 && $c <= 57) {
				STATE = 2;
				return true;
			} else if($c >= 65 && $c <= 90) {
				STATE = 2;
				return true;
			} else if($c >= 97 && $c <= 122) {
				STATE = 2;
				return true;
			} else {
				STATE = 3;
				return true;
			}
		case 3:
			return false;
		case 1:
			if($c >= 34 && $c <= 34) {
				STATE = 0;
				return true;
			} else {
				STATE = 1;
				return true;
			}
		}
		return false;
	}

	private boolean _accepted() {
		return (STATE == 0 ||
				STATE == 1 ||
				STATE == 2 ||
				STATE == 3);
	}

	private boolean _execaction(int  $c) {
		switch(STATE) {
		case 2:
			{ _apb($c);   }
			break;
		case 3:
			{ _putmp($c);       
  STATE = INITIAL;  
  UNGET($c);       }
			break;
		case 0:
			{ _apc($c); }
			break;
		case 1:
			{ _apc($c); }
			break;
		}
		return true;
	}

	public boolean matches(String s) {
		int n;

		STATE = 0;  matched = null;
		for(n = 0; n < s.length(); n++) {
			if(!_step(s.charAt(n))) {
				return false;
			}
		}

		if(_accepted()) {
			matched = s;
			return true;
		} else {
			return false;
		}
	}

	public boolean lookingAt(String s) {
		StringBuffer b = new StringBuffer();
		int n;

		STATE = 0;  matched = null;
		for(n = 0; n < s.length(); n++) {
			if(_accepted()) {
				matched = b.toString();
			}

			if(_step(s.charAt(n))) {
				// do nothing
			} else {
				return matched != null;
			}
			b.append(s.charAt(n));
		}

		if(_accepted()) {
			matched = b.toString();
			return true;
		} else {
			return matched != null;
		}
	}

	public boolean find(String s) {
		StringBuffer b;
		int n, k;

		STATE = 0;  matched = null;
		for(k = 0; k < s.length(); k++) {
			b = new StringBuffer();
			for(n = k; n < s.length(); n++) {
				if(_accepted()) {
					matched = b.toString();
				}

				if(_step(s.charAt(n))) {
					// do noting
				} else if(matched == null) {
					break;
				} else {
					return true;
				}
				b.append(s.charAt(n));
			}

			if(_accepted()) {
				matched = b.toString();
				return true;
			} else if(matched != null) {
				return true;
			} else {
				STATE = 0;
			}
		}
		return false;
	}

	public String group() {
		return matched;
	}

	public boolean parse(
			java.io.Reader rd) throws java.io.IOException {
		int c;

		if(!_execaction(-2))  return _accepted();
		while((c = _read(rd)) >= 0) {
			if(!_step(c)) {
				throw new RuntimeException();
			} else if(!_execaction(c)) {
				return _accepted();
			}
		}
		return _accepted();
	}

}
